From cf7bb9ba76d74baa9642074b0960cae536c2d787 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Jan 02 2021 21:03:28 +0000
Subject: [PATCH 1978/2232] Elide template parameters in swaps where unneeded


---

diff --git a/include/cxx.h b/include/cxx.h
index 5b4b24f..0c56848 100644
--- a/include/cxx.h
+++ b/include/cxx.h
@@ -329,7 +329,7 @@ private:
   void set_len(std::size_t len) noexcept;
   void drop() noexcept;
 
-  friend void swap(Vec<T> &lhs, Vec<T> &rhs) noexcept { lhs.swap(rhs); }
+  friend void swap(Vec &lhs, Vec &rhs) noexcept { lhs.swap(rhs); }
 
   // Size and alignment statically verified by rust_vec.rs.
   std::array<std::uintptr_t, 3> repr;
@@ -768,7 +768,7 @@ Box<T> Box<T>::in_place(Fields &&... fields) {
 }
 
 template <typename T>
-void Box<T>::swap(Box<T> &rhs) noexcept {
+void Box<T>::swap(Box &rhs) noexcept {
   using std::swap;
   swap(this->ptr, rhs.ptr);
 }
@@ -955,7 +955,7 @@ typename Vec<T>::const_iterator Vec<T>::cend() const noexcept {
 }
 
 template <typename T>
-void Vec<T>::swap(Vec<T> &rhs) noexcept {
+void Vec<T>::swap(Vec &rhs) noexcept {
   using std::swap;
   swap(this->repr, rhs.repr);
 }

